<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Card extends CI_Controller {
	
	private $upload_config;
	
	// calling the constructor
	public function __construct() {
		parent::__construct();
		if(!$this->session->userdata('id'))	redirect('admin/login');
		$this->load->model('card_model');
		$this->upload_config =  array(
			'upload_path'     => "uploads/cards/",
			'allowed_types'   => "gif|jpg|png|jpeg",
			'overwrite'       => TRUE,
			'max_size'        => "2048000",
			'max_height'      => "1024",
			'max_width'       => "1024"  
		);
	}
	
	public function index() {
		redirect('card/listing');
	}
	
	function listing() {
		$data['pageTitle'] = 'Card';
		$data['records'] = $this->card_model->get();
		$data['main_content'] = 'Card/list';
		$this->load->view('template', $data);
	}
	
	function add() {
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			$this->load->library('upload', $this->upload_config);
			
			if(!empty($_FILES['userfile']['name']))
			{
				if(!$this->upload->do_upload())
				{
					$this->session->set_flashdata('error', $this->upload->display_errors());
					redirect('card/add');
				}
				else
				{
					$data = array('upload_data' => $this->upload->data());
					$_POST['userfile'] = $data['upload_data']['file_name'];
				}
			}
			$this->card_model->update($_POST);
			$this->session->set_flashdata('success', 'New card added successfully!');
			redirect('card/listing');
		}
		$data['index_url'] = base_url("index.php/card");
		$data['pageTitle'] = 'Add new Card';
		$data['main_content'] = 'Card/add';
		//Call view
		$this->load->view('template', $data);
	}

	function edit($id = null) {
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			if(!empty($_FILES['image']['name']) || !empty($_FILES['barcode']['name']))
			{
				$row = $this->card_model->get($id);
				$this->load->library('upload', $this->upload_config);

				if(!empty($_FILES['userfile']['name']))
				{
					$filestring = PUBPATH.$this->upload_config['upload_path'].$row['image'];  
					if(file_exists($filestring))
					{
						unlink($filestring);
					}
					//Upload file
					if(!$this->upload->do_upload())
					{
						$this->session->set_flashdata('error', $this->upload->display_errors());
						redirect('card/edit/'.$id);
					}
					else
					{
						$data = array('upload_data' => $this->upload->data());
						$_POST['userfile'] = $data['upload_data']['file_name'];
					}
				}
			}
			$_POST['status'] = (isset($_POST['status']) && $_POST['status'])? 1:0;
			$this->card_model->update($_POST);
			$this->session->set_flashdata('success', 'Card edit successfully!');
			redirect('card/listing');
		}
		$data['index_url'] = base_url("index.php/card");
		$data['record'] = $this->card_model->get($id);
		$data['pageTitle'] = 'Add new Card';
		$data['main_content'] = 'Card/edit';
		//Call View
		$this->load->view('template', $data);
	}
	
	public function delete($id = null) 
	{
		//For deleting all checked record in list view
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			foreach($_POST['check'] as $card_id)
			{
				$row = $this->card_model->get($card_id);
				$filestring = PUBPATH.$this->upload_config['upload_path'].$row['userfile'];  
				if(file_exists($filestring))
				{
					unlink($filestring);
				}
				$this->card_model->remove($card_id);
			}
			$this->session->set_flashdata('success', 'Card deleted successfully');
			redirect('card/listing');
		}
		else	//For deleting single record using its ID
		{
			if ($id == null) {
				$this->session->set_flashdata('error', 'No identifier provided!');
				redirect('card/listing');
			}
			else {
				$row = $this->card_model->get($id);
				$filestring = PUBPATH.$this->upload_config['upload_path'].$row['userfile'];  
				if(file_exists($filestring))
				{
					unlink($filestring);
				}
				$this->card_model->remove($id);
				$this->session->set_flashdata('success', 'Card deleted successfully!');
				redirect('card/listing');
			}
		}
	}
}