<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Admin extends CI_Controller {
	
	// calling the constructor
	public function __construct() {
		parent::__construct();
		$this->load->model('admin_model');
		$this->load->model('city_model');
		$this->load->model('country_model');
	}
	
	function logout()
	{
		if(!$this->session->userdata('id'))	redirect('admin/login');
		$this->session->unset_userdata('id');
		$this->session->set_flashdata('success', 'You have successfully logged out !');
		redirect('admin/login');
	}
	
	function login()
	{
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			$admin = $this->admin_model->login(array('username' => $_POST['username'],'group_id' => 1));
			$pwd = $this->encrypt->decode($admin['password']);
			if($_POST['password']==$pwd)
			{
				$admin = array('id' => $admin['id'], 'name' => $admin['fname'].' '.$admin['lname'], 'email' => $admin['email']);
				$this->session->set_userdata($admin);	//Create User Session
				//Flash Success message
				$this->session->set_flashdata('success', 'You have successfully logged in !');	
				redirect('user/index');
			}
			//Flash Error message
			$this->session->set_flashdata('error', 'Your Username or Password is Incorrect !');	
			redirect('admin/login');
		}
		$data['pageTitle'] = 'Login page';
		//Call view
		$this->load->view('Admin/login',$data);
	}
	
	function index($id = 1) {
		if(!$this->session->userdata('id'))	redirect('admin/login');
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			if(!empty($_POST['city']))	
			{
				$data = array('country_id' => $_POST['country_id'],'name' => $_POST['city']);
				$_POST['city_id'] = $this->city_model->save($data);
			}
			if(isset($_POST['status']) && $_POST['status']==1)
				$status = 1;
			else
				$status = 0;
			$data = array('id' => $_POST['id'],
						  'prefix' => $_POST['prefix'],
						  'fname' => $_POST['fname'],
						  'lname' => $_POST['lname'],
						  'username' => $_POST['username'],
						  'password' => $this->encrypt->encode($_POST['password']),
						  'email' => $_POST['email'],
						  'mobile' => $_POST['mobile'],
						  'address' => $_POST['address'],
						  'postcode' => $_POST['postcode'],
						  'city_id' => $_POST['city_id'],
						  'modified' => $_POST['modified']
						 );
			$this->admin_model->update($data);
			$this->session->set_flashdata('success', 'Admin details updated successfully!');
			redirect('admin/index');
		}
		$data['record'] = $this->admin_model->get($id);
		$data['record']['password'] = $this->encrypt->decode($data['record']['password']);
		$data['location'] = $this->city_model->get($data['record']['city_id']);
		$data['countries'] = $this->country_model->getAll();
		$data['index_url'] = base_url("index.php/user");
		$data['pageTitle'] = 'Admin Panel';
		$data['main_content'] = 'Admin/index';
		//Call view
		$this->load->view('template', $data);
	}
}