<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class News extends CI_Controller {
	
	private $upload_config;
	private $thumb_config;
	
	// calling the constructor
	public function __construct() {
		parent::__construct();
		if(!$this->session->userdata('id'))	redirect('admin/login');
		$this->load->model('news_model');
		$this->upload_config =  array(
			'upload_path'     => "uploads/news/",
			'allowed_types'   => "gif|jpg|png|jpeg",
			'overwrite'       => TRUE,
			'max_size'        => "2048000",
/*			'max_height'      => "500",
			'max_width'       => "1250"*/  
		);

		$this->thumb_config = array(
			'image_library' => 'gd2',
			'source_image'	=> $this->upload_config['upload_path'],
			'new_image'		=> $this->upload_config['upload_path'].'thumb/',
			'maintain_ratio'=> FALSE,
			'width' 	=> 50,
			'height'	=> 50
		);	
	}
	
	public function index() {
		redirect('news/listing');
	}
	
	function listing() {
		$data['pageTitle'] = 'News';
		$data['records'] = $this->news_model->get();
		$data['main_content'] = 'News/list';
		//Call view
		$this->load->view('template', $data);
	}
	
/*	function add() {
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			$this->load->library('upload', $this->upload_config);
			if(!$this->upload->do_upload())
			{
				$this->session->set_flashdata('error', $this->upload->display_errors());
				redirect('news/add');
			}
			else
			{
				$data = array('upload_data' => $this->upload->data());
				$upload_data = $data['upload_data'];
				$_POST['userfile'] = $upload_data['file_name'];
				$this->thumb_config['source_image'] = $upload_data['full_path'];
				$this->thumb_config['new_image'] = $this->thumb_config['new_image'].'thumb_'.$upload_data['file_name'];
				$this->image_lib->initialize($this->thumb_config);
				$this->image_lib->resize();
				//Insert new data
				$this->news_model->update($_POST);
				$this->session->set_flashdata('success', 'News add successfully!');
				redirect('news/listing');
			}
		}
		$data['index_url'] = base_url("index.php/news");
		$data['pageTitle'] = 'Add new News';
		$data['main_content'] = 'News/add';
		//Call view
		$this->load->view('template', $data);
	}*/
	function add() 
	{
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			if(!empty($_FILES['userfile']['name']))
			{
				$file = PUBPATH.$this->upload_config['upload_path'].$_FILES['userfile']['name'];
				$thumb = PUBPATH.$this->thumb_config['new_image'].'thumb_'.$_FILES['userfile']['name'];

				if(file_exists($file) && file_exists($thumb))
				{
					unlink($file);
					unlink($thumb);
				}
				//Upload file
				$this->load->library('upload', $this->upload_config);
				if(!$this->upload->do_upload())
				{
					$this->session->set_flashdata('error', $this->upload->display_errors());
					redirect('news/add');
				}
				else
				{
					$data = array('upload_data' => $this->upload->data());
					$upload_data = $data['upload_data'];
					$_POST['userfile'] = $upload_data['file_name'];
					$this->thumb_config['source_image'] = $upload_data['full_path'];
					$this->thumb_config['new_image'] = $this->thumb_config['new_image'].'thumb_'.$upload_data['file_name'];
					$this->image_lib->initialize($this->thumb_config);
					$this->image_lib->resize();
				}
			}
			$_POST['status'] = (isset($_POST['status']) && $_POST['status'])? 1:0;
			$this->news_model->update($_POST);
			$this->session->set_flashdata('success', 'News added successfully!');
			redirect('news/listing');
		}
		$data['index_url'] = base_url("index.php/news");
		$data['pageTitle'] = 'Add News';
		$data['main_content'] = 'News/add';
		//Call view
		$this->load->view('template', $data);
	}

	function edit($id = null) 
	{
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			if(!empty($_FILES['userfile']['name']))
			{
				$row = $this->news_model->get($id);
				$file = PUBPATH.$this->upload_config['upload_path'].$row['userfile'];
				$thumb = PUBPATH.$this->thumb_config['new_image'].'thumb_'.$row['userfile'];

				if(file_exists($file) && file_exists($thumb))
				{
					unlink($file);
					unlink($thumb);
				}
				//Upload file
				$this->load->library('upload', $this->upload_config);
				if(!$this->upload->do_upload())
				{
					$this->session->set_flashdata('error', $this->upload->display_errors());
					redirect('news/edit/'.$id);
				}
				else
				{
					$data = array('upload_data' => $this->upload->data());
					$upload_data = $data['upload_data'];
					$_POST['userfile'] = $upload_data['file_name'];
					$this->thumb_config['source_image'] = $upload_data['full_path'];
					$this->thumb_config['new_image'] = $this->thumb_config['new_image'].'thumb_'.$upload_data['file_name'];
					$this->image_lib->initialize($this->thumb_config);
					$this->image_lib->resize();
				}
			}
			$_POST['status'] = (isset($_POST['status']) && $_POST['status'])? 1:0;
			$this->news_model->update($_POST);
			$this->session->set_flashdata('success', 'News edit successfully!');
			redirect('news/listing');
		}
		$data['index_url'] = base_url("index.php/news");
		$data['record'] = $this->news_model->get($id);
		$data['pageTitle'] = 'Edit News';
		$data['main_content'] = 'News/edit';
		//Call view
		$this->load->view('template', $data);
	}
	
	public function delete($id = null) {
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			foreach($_POST['check'] as $news_id)
			{
				$row = $this->news_model->get($news_id);
				$file = PUBPATH.$this->upload_config['upload_path'].$row['userfile'];
				$thumb = PUBPATH.$this->thumb_config['new_image'].'thumb_'.$row['userfile'];
				
				if(file_exists($file) && file_exists($thumb))
				{
					unlink($file);
					unlink($thumb);
				}
				$this->news_model->remove($news_id);
			}
			$this->session->set_flashdata('success', 'News deleted successfully!');
			redirect('news/listing');
		}
		else
		{
			if ($id == null) {
				$this->session->set_flashdata('error', 'No identifier provided!');
				redirect('news/listing');
			}
			else {
				$row = $this->news_model->get($id);
				$file = PUBPATH.$this->upload_config['upload_path'].$row['userfile'];
				$thumb = PUBPATH.$this->thumb_config['new_image'].'thumb_'.$row['userfile'];
				
				if(file_exists($file) && file_exists($thumb))
				{
					unlink($file);
					unlink($thumb);
				}
				$this->news_model->remove($id);
				$this->session->set_flashdata('success', 'News deleted successfully!');
				redirect('news/listing');
			}
		}
	}
}