<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class User extends CI_Controller {
	
	var $config_email;
	
	// calling the constructor
	public function __construct() {
		parent::__construct();
		if(!$this->session->userdata('id'))	redirect('admin/login');
		$this->load->model('user_model');
		$this->load->model('city_model');
		$this->load->model('country_model');
		$this->config_email = array(		
		    'protocol' 	=> 'smtp',
		    'smtp_host' => 'ssl://smtp.googlemail.com',
		    'smtp_port' => 465,
		    'smtp_user' => 'digitalcards.nl@gmail.com',
		    'smtp_pass' => 'digital@123',
		    'smtp_timeout' => '4',
		    'mailtype'  => 'text', 
		    'charset'   => 'utf-8',
			'newline'	=> "\r\n"
		);
	}
	
	public function email($id = null)
	{
		$this->load->library('email', $this->config_email);
		$admin_email = trim($this->session->userdata('email'));

		$data = $this->user_model->get($id);
		extract($data);
		$password = base64_decode($password);	//$this->encrypt->decode($password);
		
		$this->email->from($admin_email, 'Van Halteren');
		$this->email->to($email);

		$this->email->subject('E-mail van Van Halteren');
		
		$body = "Geachte heer/mevrouw,\n\nBedankt voor het aanvragen van de digitale Van Halteren klantenkaart. Uw aanvraag is goedgekeurd. U kunt de onderstaande gegevens gebruiken om in te loggen in de Van Halteren app.\n-----------------------\nUsername : $username\nPassword : $password\n-----------------------\nMet vriendelijke groet,\n\nTeam Van Halteren Watersport & Outdoor";
		
		$this->email->message($body);
		
		if($this->email->send())
			$this->session->set_flashdata('success', 'Email sent successfully!');
		else
			$this->session->set_flashdata('error', $this->email->print_debugger());
		redirect('user/edit/'.$id);
	}

	public function index() {
		redirect('user/listing');
	}
	
	function listing() {
		$data['pageTitle'] = 'User';
		$data['records'] = $this->user_model->get();
		$data['main_content'] = 'User/list';
		$this->load->view('template', $data);
	}
	
	function add() {
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			if(!empty($_POST['city']))	
			{
				$data = array('country_id' => $_POST['country_id'],'name' => $_POST['city']);
				$_POST['city_id'] = $this->city_model->save($data);
			}
			$data = array(
				'prefix' => $_POST['prefix'],
				'fname' => $_POST['fname'],
				'lname' => $_POST['lname'],
				'username' => $_POST['username'],
				'email' => $_POST['email'],
				'mobile' => $_POST['mobile'],
				'address' => $_POST['address'],
				'postcode' => $_POST['postcode'],
				'city_id' => $_POST['city_id'],
				'status' => $_POST['status'],
				'created' => $_POST['created'],
				'group_id' => 2 //1::Admin, 2::User
			);
			
			if($_POST['password']!='')
			{
				$encrypted_string = base64_encode($_POST['password']);
				//$this->encrypt->encode($str);
			}
			else
			{
				$str = random_string('alnum', 8);
				$encrypted_string = base64_encode($str);
			}
			$_POST['password'] = $encrypted_string;
			
			if($_POST['status'])
			{
				$data['barcode'] = random_string('numeric', 12);
			}
			$this->user_model->update($data);
			$this->session->set_flashdata('success', 'User added successfully!');
			redirect('user/listing');
		}
		$data['countries'] = $this->country_model->getAll();
		$data['index_url'] = base_url("index.php/user");
		$data['pageTitle'] = 'Add new User';
		$data['main_content'] = 'User/add';
		//Call view
		$this->load->view('template', $data);
	}
	
	function edit($id = null)
	{
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			if(!empty($_POST['city']))	
			{
				$data = array('country_id' => $_POST['country_id'],'name' => $_POST['city']);
				$_POST['city_id'] = $this->city_model->save($data);
			}

			$status = (isset($_POST['status']) && $_POST['status'])? 1:0;

			$data = array(
				'id' => $_POST['id'],
				'prefix' => $_POST['prefix'],
				'fname' => $_POST['fname'],
				'lname' => $_POST['lname'],
				'username' => $_POST['username'],
				'password' => base64_encode($_POST['password']),
				'email' => $_POST['email'],
				'mobile' => $_POST['mobile'],
				'address' => $_POST['address'],
				'postcode' => $_POST['postcode'],
				'city_id' => $_POST['city_id'],
				'status' => $status,
				'modified' => $_POST['modified']
			);
						 
			$prev = $this->user_model->get($id);
			if((isset($_POST['status']) && $_POST['status']) && !$prev['status'])
			{
				if($_POST['password']!='')
					$str = $_POST['password'];
				else
					$str = random_string('alnum', 8);
				$encrypted_string = base64_encode($str);	//$this->encrypt->encode($str);
				$data['password'] = $encrypted_string;
				$data['barcode']  = random_string('numeric', 12);
				generate_barcode($data['barcode'],$id);
			}

			$this->session->set_flashdata('success', 'User edited successfully!');
			$this->user_model->update($data);
			redirect('user/listing');
		}
		$data['record'] = $this->user_model->get($id);
		$data['record']['password'] = base64_decode($data['record']['password']);
		$data['location'] = $this->city_model->get($data['record']['city_id']);
		$data['countries'] = $this->country_model->getAll();
		$data['index_url'] = base_url("index.php/user");
		$data['pageTitle'] = 'Update User';
		$data['main_content'] = 'User/edit';
		//Call view
		$this->load->view('template', $data);
	}
	
	public function delete($id = null) {
		if($_SERVER['REQUEST_METHOD']=='POST')
		{
			foreach($_POST['check'] as $user_id)
			{
				$this->user_model->remove($user_id);
			}
			$this->session->set_flashdata('success', 'User deleted successfully!');
			redirect('user/listing');
		}
		else
		{
			if ($id == null) {
				$this->session->set_flashdata('error', 'No identifier found!');
				redirect('user/listing');
			}
			else {
				$this->user_model->remove($id);
				$this->session->set_flashdata('success', 'User deleted successfully!');
				redirect('user/listing');
			}
		}
	}
}